---
layout: homepage
title: MikroORM v3
hide_title: true
---

## Table of contents

- Overview
  - [Installation & Usage](installation.md)
  - [Defining Entities](defining-entities.md)
  - [Persisting, Cascading and Fetching Entities with `EntityManager`](entity-manager.md)
  - [Using `EntityRepository` instead of `EntityManager`](repositories.md)
- Fundamentals
  - [Identity Map and Request Context](identity-map.md)
  - [Entity References and `Reference<T>` Wrapper](entity-references.md)
  - [Using Entity Constructors](entity-constructors.md)
  - [Modelling Relationships](relationships.md)
  - [Collections](collections.md)
  - [Unit of Work](unit-of-work.md)
  - [Transactions](transactions.md)
  - [Cascading persist and remove](cascading.md)
  - [Deployment](deployment.md)
- Advanced Features
  - [Smart Nested Populate](nested-populate.md)
  - [Smart Query Conditions](query-conditions.md)
  - [Using `QueryBuilder`](query-builder.md)
  - [Serializing](serializing.md)
  - [Updating Entity Values with `Entity.assign()`](entity-helper.md)
  - [Property Validation](property-validation.md)
  - [Lifecycle Hooks](lifecycle-hooks.md)
  - [Naming Strategy](naming-strategy.md)
  - [Metadata Providers](metadata-providers.md)
  - [Metadata Cache](metadata-cache.md)
  - [Debugging](debugging.md)
  - [Schema Generator](schema-generator.md)
  - [Entity Generator](entity-generator.md)
  - [Migrations](migrations.md)
  - [Read Replica Connections](read-connections.md)
- Usage with Different Drivers
  - [Usage with SQL Drivers](usage-with-sql.md)
  - [Usage with MongoDB](usage-with-mongo.md)
- Recipes
  - [Usage with NestJS](usage-with-nestjs.md)
  - [Usage with Vanilla JS](usage-with-js.md)
  - [Creating Custom Driver](custom-driver.md)
  - [Using Multiple Schemas](multiple-schemas.md)
- Example Integrations
  - [Express + MongoDB + TypeScript](https://github.com/mikro-orm/mikro-orm-examples/tree/master/express-ts)
  - [Nest + MySQL + TypeScript](https://github.com/mikro-orm/mikro-orm-examples/tree/master/nest)
  - [RealWorld example app (Nest + MySQL)](https://github.com/mikro-orm/nestjs-realworld-example-app)
  - [Express + MongoDB + JavaScript](https://github.com/mikro-orm/mikro-orm-examples/tree/master/express-js)
